#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK0x0x15TN1x1x15_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=15, 
 * lda=15, ldb=15, ldc=0, mu=1, nu=1, ku=15, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   #define Mb M
   #define Nb N
   const double *stM = A + (15*(Mb));
   const double *stN = B + (15*(Nb));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*1)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 15
   const int incAm = 0, incAn = -(15*(Mb));
   #define incBk 15
   const int incBm = -15, incBn = 15;
   const int incAk0 = ((incAk) / 15), incBk0 = ((incBk) / 15);
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0;
   register double m0;
   register double rC0_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];

/*
 *       Completely unrolled K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[7];
         rB0 = pB0[7];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[9];
         rB0 = pB0[9];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[10];
         rB0 = pB0[10];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[11];
         rB0 = pB0[11];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[12];
         rB0 = pB0[12];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[13];
         rB0 = pB0[13];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[14];
         rB0 = pB0[14];
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         pA0 += incAk;
         pB0 += incBk;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_dJIK0x0x15TN15x15x0_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=15, 
 * lda=15, ldb=15, ldc=0, mu=12, nu=1, ku=15, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   const int Mb = (M/12)*12;
   #define Nb N
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (15*(Mb));
   const double *stN = B + (15*(Nb));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*12*1)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 15
   const int incAm = 165, incAn = -(15*(Mb));
   #define incBk 15
   const int incBm = -15, incBn = 15;
   const int incAk0 = ((incAk) / 15), incBk0 = ((incBk) / 15);
   #define incCm 12
   const int incCn = (ldc) - (Mb);
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7, rA8, rA9, rA10, rA11;
   register double rB0;
   register double m0;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC8_0, rC9_0, rC10_0, rC11_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
            rC3_0 = pC0[3];
            rC3_0 *= rA0;
            rC4_0 = pC0[4];
            rC4_0 *= rA0;
            rC5_0 = pC0[5];
            rC5_0 *= rA0;
            rC6_0 = pC0[6];
            rC6_0 *= rA0;
            rC7_0 = pC0[7];
            rC7_0 *= rA0;
            rC8_0 = pC0[8];
            rC8_0 *= rA0;
            rC9_0 = pC0[9];
            rC9_0 *= rA0;
            rC10_0 = pC0[10];
            rC10_0 *= rA0;
            rC11_0 = pC0[11];
            rC11_0 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[15];
            rA2 = pA0[30];
            rA3 = pA0[45];
            rA4 = pA0[60];
            rA5 = pA0[75];
            rA6 = pA0[90];
            rA7 = pA0[105];
            rA8 = pA0[120];
            rA9 = pA0[135];
            rA10 = pA0[150];
            m0 = rA0 * rB0;
            rA11 = pA0[165];

/*
 *          Completely unrolled K-loop
 */
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA5 * rB0;
            rC5_0 += m0;
            m0 = rA6 * rB0;
            rC6_0 += m0;
            m0 = rA7 * rB0;
            rC7_0 += m0;
            m0 = rA8 * rB0;
            rC8_0 += m0;
            m0 = rA9 * rB0;
            rC9_0 += m0;
            m0 = rA10 * rB0;
            rC10_0 += m0;
            m0 = rA11 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[16];
            rA2 = pA0[31];
            rA3 = pA0[46];
            rA4 = pA0[61];
            rA5 = pA0[76];
            rA6 = pA0[91];
            rA7 = pA0[106];
            rA8 = pA0[121];
            rA9 = pA0[136];
            rA10 = pA0[151];
            rA11 = pA0[166];
            rC11_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA5 * rB0;
            rC5_0 += m0;
            m0 = rA6 * rB0;
            rC6_0 += m0;
            m0 = rA7 * rB0;
            rC7_0 += m0;
            m0 = rA8 * rB0;
            rC8_0 += m0;
            m0 = rA9 * rB0;
            rC9_0 += m0;
            m0 = rA10 * rB0;
            rC10_0 += m0;
            m0 = rA11 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[17];
            rA2 = pA0[32];
            rA3 = pA0[47];
            rA4 = pA0[62];
            rA5 = pA0[77];
            rA6 = pA0[92];
            rA7 = pA0[107];
            rA8 = pA0[122];
            rA9 = pA0[137];
            rA10 = pA0[152];
            rA11 = pA0[167];
            rC11_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA5 * rB0;
            rC5_0 += m0;
            m0 = rA6 * rB0;
            rC6_0 += m0;
            m0 = rA7 * rB0;
            rC7_0 += m0;
            m0 = rA8 * rB0;
            rC8_0 += m0;
            m0 = rA9 * rB0;
            rC9_0 += m0;
            m0 = rA10 * rB0;
            rC10_0 += m0;
            m0 = rA11 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA0[18];
            rA2 = pA0[33];
            rA3 = pA0[48];
            rA4 = pA0[63];
            rA5 = pA0[78];
            rA6 = pA0[93];
            rA7 = pA0[108];
            rA8 = pA0[123];
            rA9 = pA0[138];
            rA10 = pA0[153];
            rA11 = pA0[168];
            rC11_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA5 * rB0;
            rC5_0 += m0;
            m0 = rA6 * rB0;
            rC6_0 += m0;
            m0 = rA7 * rB0;
            rC7_0 += m0;
            m0 = rA8 * rB0;
            rC8_0 += m0;
            m0 = rA9 * rB0;
            rC9_0 += m0;
            m0 = rA10 * rB0;
            rC10_0 += m0;
            m0 = rA11 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA0[19];
            rA2 = pA0[34];
            rA3 = pA0[49];
            rA4 = pA0[64];
            rA5 = pA0[79];
            rA6 = pA0[94];
            rA7 = pA0[109];
            rA8 = pA0[124];
            rA9 = pA0[139];
            rA10 = pA0[154];
            rA11 = pA0[169];
            rC11_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA5 * rB0;
            rC5_0 += m0;
            m0 = rA6 * rB0;
            rC6_0 += m0;
            m0 = rA7 * rB0;
            rC7_0 += m0;
            m0 = rA8 * rB0;
            rC8_0 += m0;
            m0 = rA9 * rB0;
            rC9_0 += m0;
            m0 = rA10 * rB0;
            rC10_0 += m0;
            m0 = rA11 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rA1 = pA0[20];
            rA2 = pA0[35];
            rA3 = pA0[50];
            rA4 = pA0[65];
            rA5 = pA0[80];
            rA6 = pA0[95];
            rA7 = pA0[110];
            rA8 = pA0[125];
            rA9 = pA0[140];
            rA10 = pA0[155];
            rA11 = pA0[170];
            rC11_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA5 * rB0;
            rC5_0 += m0;
            m0 = rA6 * rB0;
            rC6_0 += m0;
            m0 = rA7 * rB0;
            rC7_0 += m0;
            m0 = rA8 * rB0;
            rC8_0 += m0;
            m0 = rA9 * rB0;
            rC9_0 += m0;
            m0 = rA10 * rB0;
            rC10_0 += m0;
            m0 = rA11 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rA1 = pA0[21];
            rA2 = pA0[36];
            rA3 = pA0[51];
            rA4 = pA0[66];
            rA5 = pA0[81];
            rA6 = pA0[96];
            rA7 = pA0[111];
            rA8 = pA0[126];
            rA9 = pA0[141];
            rA10 = pA0[156];
            rA11 = pA0[171];
            rC11_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA5 * rB0;
            rC5_0 += m0;
            m0 = rA6 * rB0;
            rC6_0 += m0;
            m0 = rA7 * rB0;
            rC7_0 += m0;
            m0 = rA8 * rB0;
            rC8_0 += m0;
            m0 = rA9 * rB0;
            rC9_0 += m0;
            m0 = rA10 * rB0;
            rC10_0 += m0;
            m0 = rA11 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rA1 = pA0[22];
            rA2 = pA0[37];
            rA3 = pA0[52];
            rA4 = pA0[67];
            rA5 = pA0[82];
            rA6 = pA0[97];
            rA7 = pA0[112];
            rA8 = pA0[127];
            rA9 = pA0[142];
            rA10 = pA0[157];
            rA11 = pA0[172];
            rC11_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA5 * rB0;
            rC5_0 += m0;
            m0 = rA6 * rB0;
            rC6_0 += m0;
            m0 = rA7 * rB0;
            rC7_0 += m0;
            m0 = rA8 * rB0;
            rC8_0 += m0;
            m0 = rA9 * rB0;
            rC9_0 += m0;
            m0 = rA10 * rB0;
            rC10_0 += m0;
            m0 = rA11 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rA1 = pA0[23];
            rA2 = pA0[38];
            rA3 = pA0[53];
            rA4 = pA0[68];
            rA5 = pA0[83];
            rA6 = pA0[98];
            rA7 = pA0[113];
            rA8 = pA0[128];
            rA9 = pA0[143];
            rA10 = pA0[158];
            rA11 = pA0[173];
            rC11_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA5 * rB0;
            rC5_0 += m0;
            m0 = rA6 * rB0;
            rC6_0 += m0;
            m0 = rA7 * rB0;
            rC7_0 += m0;
            m0 = rA8 * rB0;
            rC8_0 += m0;
            m0 = rA9 * rB0;
            rC9_0 += m0;
            m0 = rA10 * rB0;
            rC10_0 += m0;
            m0 = rA11 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rA1 = pA0[24];
            rA2 = pA0[39];
            rA3 = pA0[54];
            rA4 = pA0[69];
            rA5 = pA0[84];
            rA6 = pA0[99];
            rA7 = pA0[114];
            rA8 = pA0[129];
            rA9 = pA0[144];
            rA10 = pA0[159];
            rA11 = pA0[174];
            rC11_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA5 * rB0;
            rC5_0 += m0;
            m0 = rA6 * rB0;
            rC6_0 += m0;
            m0 = rA7 * rB0;
            rC7_0 += m0;
            m0 = rA8 * rB0;
            rC8_0 += m0;
            m0 = rA9 * rB0;
            rC9_0 += m0;
            m0 = rA10 * rB0;
            rC10_0 += m0;
            m0 = rA11 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rA1 = pA0[25];
            rA2 = pA0[40];
            rA3 = pA0[55];
            rA4 = pA0[70];
            rA5 = pA0[85];
            rA6 = pA0[100];
            rA7 = pA0[115];
            rA8 = pA0[130];
            rA9 = pA0[145];
            rA10 = pA0[160];
            rA11 = pA0[175];
            rC11_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA5 * rB0;
            rC5_0 += m0;
            m0 = rA6 * rB0;
            rC6_0 += m0;
            m0 = rA7 * rB0;
            rC7_0 += m0;
            m0 = rA8 * rB0;
            rC8_0 += m0;
            m0 = rA9 * rB0;
            rC9_0 += m0;
            m0 = rA10 * rB0;
            rC10_0 += m0;
            m0 = rA11 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rA1 = pA0[26];
            rA2 = pA0[41];
            rA3 = pA0[56];
            rA4 = pA0[71];
            rA5 = pA0[86];
            rA6 = pA0[101];
            rA7 = pA0[116];
            rA8 = pA0[131];
            rA9 = pA0[146];
            rA10 = pA0[161];
            rA11 = pA0[176];
            rC11_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA5 * rB0;
            rC5_0 += m0;
            m0 = rA6 * rB0;
            rC6_0 += m0;
            m0 = rA7 * rB0;
            rC7_0 += m0;
            m0 = rA8 * rB0;
            rC8_0 += m0;
            m0 = rA9 * rB0;
            rC9_0 += m0;
            m0 = rA10 * rB0;
            rC10_0 += m0;
            m0 = rA11 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rA1 = pA0[27];
            rA2 = pA0[42];
            rA3 = pA0[57];
            rA4 = pA0[72];
            rA5 = pA0[87];
            rA6 = pA0[102];
            rA7 = pA0[117];
            rA8 = pA0[132];
            rA9 = pA0[147];
            rA10 = pA0[162];
            rA11 = pA0[177];
            rC11_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA5 * rB0;
            rC5_0 += m0;
            m0 = rA6 * rB0;
            rC6_0 += m0;
            m0 = rA7 * rB0;
            rC7_0 += m0;
            m0 = rA8 * rB0;
            rC8_0 += m0;
            m0 = rA9 * rB0;
            rC9_0 += m0;
            m0 = rA10 * rB0;
            rC10_0 += m0;
            m0 = rA11 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rA1 = pA0[28];
            rA2 = pA0[43];
            rA3 = pA0[58];
            rA4 = pA0[73];
            rA5 = pA0[88];
            rA6 = pA0[103];
            rA7 = pA0[118];
            rA8 = pA0[133];
            rA9 = pA0[148];
            rA10 = pA0[163];
            rA11 = pA0[178];
            rC11_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA5 * rB0;
            rC5_0 += m0;
            m0 = rA6 * rB0;
            rC6_0 += m0;
            m0 = rA7 * rB0;
            rC7_0 += m0;
            m0 = rA8 * rB0;
            rC8_0 += m0;
            m0 = rA9 * rB0;
            rC9_0 += m0;
            m0 = rA10 * rB0;
            rC10_0 += m0;
            m0 = rA11 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rA1 = pA0[29];
            rA2 = pA0[44];
            rA3 = pA0[59];
            rA4 = pA0[74];
            rA5 = pA0[89];
            rA6 = pA0[104];
            rA7 = pA0[119];
            rA8 = pA0[134];
            rA9 = pA0[149];
            rA10 = pA0[164];
            rA11 = pA0[179];
            rC11_0 += m0;
            m0 = rA0 * rB0;
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA5 * rB0;
            rC5_0 += m0;
            m0 = rA6 * rB0;
            rC6_0 += m0;
            m0 = rA7 * rB0;
            rC7_0 += m0;
            m0 = rA8 * rB0;
            rC8_0 += m0;
            m0 = rA9 * rB0;
            rC9_0 += m0;
            m0 = rA10 * rB0;
            rC10_0 += m0;
            m0 = rA11 * rB0;
            rC11_0 += m0;
            pA0 += incAk;
            pB0 += incBk;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0[4] = rC4_0;
            pC0[5] = rC5_0;
            pC0[6] = rC6_0;
            pC0[7] = rC7_0;
            pC0[8] = rC8_0;
            pC0[9] = rC9_0;
            pC0[10] = rC10_0;
            pC0[11] = rC11_0;
            pC0 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_dJIK0x0x15TN1x1x15_a1_bX(k, N, 15, alpha, ca + (15*(Mb)), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
