#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK0x0x6TN1x1x6_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=6, 
 * lda=6, ldb=6, ldc=0, mu=1, nu=1, ku=6, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   #define Mb M
   #define Nb N
   const double *stM = A + (((Mb) << 2)+((Mb) << 1));
   const double *stN = B + (((Nb) << 2)+((Nb) << 1));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*1)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 6
   const int incAm = 0, incAn = -(((Mb) << 2)+((Mb) << 1));
   #define incBk 6
   const int incBm = -6, incBn = 6;
   const int incAk0 = ((incAk) / 6), incBk0 = ((incBk) / 6);
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0;
   register double m0;
   register double rC0_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];

/*
 *       Completely unrolled K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[5];
         rB0 = pB0[5];
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         pA0 += incAk;
         pB0 += incBk;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_dJIK0x0x6TN6x6x0_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=6, 
 * lda=6, ldb=6, ldc=0, mu=12, nu=1, ku=6, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   const int Mb = (M/12)*12;
   #define Nb N
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (((Mb) << 2)+((Mb) << 1));
   const double *stN = B + (((Nb) << 2)+((Nb) << 1));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*12*1)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 6
   const int incAm = 66, incAn = -(((Mb) << 2)+((Mb) << 1));
   #define incBk 6
   const int incBm = -6, incBn = 6;
   const int incAk0 = ((incAk) / 6), incBk0 = ((incBk) / 6);
   #define incCm 12
   const int incCn = (ldc) - (Mb);
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7, rA8, rA9, rA10, rA11;
   register double rB0;
   register double m0;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC8_0, rC9_0, rC10_0, rC11_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
            rC3_0 = pC0[3];
            rC3_0 *= rA0;
            rC4_0 = pC0[4];
            rC4_0 *= rA0;
            rC5_0 = pC0[5];
            rC5_0 *= rA0;
            rC6_0 = pC0[6];
            rC6_0 *= rA0;
            rC7_0 = pC0[7];
            rC7_0 *= rA0;
            rC8_0 = pC0[8];
            rC8_0 *= rA0;
            rC9_0 = pC0[9];
            rC9_0 *= rA0;
            rC10_0 = pC0[10];
            rC10_0 *= rA0;
            rC11_0 = pC0[11];
            rC11_0 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[6];
            rA2 = pA0[12];
            rA3 = pA0[18];
            rA4 = pA0[24];
            rA5 = pA0[30];
            rA6 = pA0[36];
            rA7 = pA0[42];
            rA8 = pA0[48];
            rA9 = pA0[54];
            rA10 = pA0[60];
            m0 = rA0 * rB0;
            rA11 = pA0[66];

/*
 *          Completely unrolled K-loop
 */
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA5 * rB0;
            rC5_0 += m0;
            m0 = rA6 * rB0;
            rC6_0 += m0;
            m0 = rA7 * rB0;
            rC7_0 += m0;
            m0 = rA8 * rB0;
            rC8_0 += m0;
            m0 = rA9 * rB0;
            rC9_0 += m0;
            m0 = rA10 * rB0;
            rC10_0 += m0;
            m0 = rA11 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[7];
            rA2 = pA0[13];
            rA3 = pA0[19];
            rA4 = pA0[25];
            rA5 = pA0[31];
            rA6 = pA0[37];
            rA7 = pA0[43];
            rA8 = pA0[49];
            rA9 = pA0[55];
            rA10 = pA0[61];
            rA11 = pA0[67];
            rC11_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA5 * rB0;
            rC5_0 += m0;
            m0 = rA6 * rB0;
            rC6_0 += m0;
            m0 = rA7 * rB0;
            rC7_0 += m0;
            m0 = rA8 * rB0;
            rC8_0 += m0;
            m0 = rA9 * rB0;
            rC9_0 += m0;
            m0 = rA10 * rB0;
            rC10_0 += m0;
            m0 = rA11 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[8];
            rA2 = pA0[14];
            rA3 = pA0[20];
            rA4 = pA0[26];
            rA5 = pA0[32];
            rA6 = pA0[38];
            rA7 = pA0[44];
            rA8 = pA0[50];
            rA9 = pA0[56];
            rA10 = pA0[62];
            rA11 = pA0[68];
            rC11_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA5 * rB0;
            rC5_0 += m0;
            m0 = rA6 * rB0;
            rC6_0 += m0;
            m0 = rA7 * rB0;
            rC7_0 += m0;
            m0 = rA8 * rB0;
            rC8_0 += m0;
            m0 = rA9 * rB0;
            rC9_0 += m0;
            m0 = rA10 * rB0;
            rC10_0 += m0;
            m0 = rA11 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA0[9];
            rA2 = pA0[15];
            rA3 = pA0[21];
            rA4 = pA0[27];
            rA5 = pA0[33];
            rA6 = pA0[39];
            rA7 = pA0[45];
            rA8 = pA0[51];
            rA9 = pA0[57];
            rA10 = pA0[63];
            rA11 = pA0[69];
            rC11_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA5 * rB0;
            rC5_0 += m0;
            m0 = rA6 * rB0;
            rC6_0 += m0;
            m0 = rA7 * rB0;
            rC7_0 += m0;
            m0 = rA8 * rB0;
            rC8_0 += m0;
            m0 = rA9 * rB0;
            rC9_0 += m0;
            m0 = rA10 * rB0;
            rC10_0 += m0;
            m0 = rA11 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA0[10];
            rA2 = pA0[16];
            rA3 = pA0[22];
            rA4 = pA0[28];
            rA5 = pA0[34];
            rA6 = pA0[40];
            rA7 = pA0[46];
            rA8 = pA0[52];
            rA9 = pA0[58];
            rA10 = pA0[64];
            rA11 = pA0[70];
            rC11_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA5 * rB0;
            rC5_0 += m0;
            m0 = rA6 * rB0;
            rC6_0 += m0;
            m0 = rA7 * rB0;
            rC7_0 += m0;
            m0 = rA8 * rB0;
            rC8_0 += m0;
            m0 = rA9 * rB0;
            rC9_0 += m0;
            m0 = rA10 * rB0;
            rC10_0 += m0;
            m0 = rA11 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rA1 = pA0[11];
            rA2 = pA0[17];
            rA3 = pA0[23];
            rA4 = pA0[29];
            rA5 = pA0[35];
            rA6 = pA0[41];
            rA7 = pA0[47];
            rA8 = pA0[53];
            rA9 = pA0[59];
            rA10 = pA0[65];
            rA11 = pA0[71];
            rC11_0 += m0;
            m0 = rA0 * rB0;
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA5 * rB0;
            rC5_0 += m0;
            m0 = rA6 * rB0;
            rC6_0 += m0;
            m0 = rA7 * rB0;
            rC7_0 += m0;
            m0 = rA8 * rB0;
            rC8_0 += m0;
            m0 = rA9 * rB0;
            rC9_0 += m0;
            m0 = rA10 * rB0;
            rC10_0 += m0;
            m0 = rA11 * rB0;
            rC11_0 += m0;
            pA0 += incAk;
            pB0 += incBk;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0[4] = rC4_0;
            pC0[5] = rC5_0;
            pC0[6] = rC6_0;
            pC0[7] = rC7_0;
            pC0[8] = rC8_0;
            pC0[9] = rC9_0;
            pC0[10] = rC10_0;
            pC0[11] = rC11_0;
            pC0 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_dJIK0x0x6TN1x1x6_a1_bX(k, N, 6, alpha, ca + (((Mb) << 2)+((Mb) << 1)), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
