#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x36NN1x1x36_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=0, NB=0, KB=36, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=36, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   #define Mb M
   #define Nb N
   const float *stM = A + (Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 1 - (((lda) << 5)+((lda) << 2)), incAn = -(Mb);
   #define incBk 36
   const int incBm = -36, incBn = (ldb);
   #define incAk0 incAk
   const int incBk0 = ((incBk) / 36);
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float m0, m1, m2, m3, m4, m5;
   register float rC0_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[1];
         m1 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[2];
         m2 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[3];
         m3 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[4];
         m4 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[5];
         m5 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[6];

/*
 *       Completely unrolled K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[7];
         rC0_0 += m1;
         m1 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[8];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[9];
         rC0_0 += m3;
         m3 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[10];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[11];
         rC0_0 += m5;
         m5 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[12];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[13];
         rC0_0 += m1;
         m1 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[14];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[15];
         rC0_0 += m3;
         m3 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[16];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[17];
         rC0_0 += m5;
         m5 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[18];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[19];
         rC0_0 += m1;
         m1 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[20];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[21];
         rC0_0 += m3;
         m3 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[22];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[23];
         rC0_0 += m5;
         m5 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[24];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[25];
         rC0_0 += m1;
         m1 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[26];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[27];
         rC0_0 += m3;
         m3 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[28];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[29];
         rC0_0 += m5;
         m5 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[30];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[31];
         rC0_0 += m1;
         m1 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[32];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[33];
         rC0_0 += m3;
         m3 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[34];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[35];
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m5;
         m5 = rA0 * rB0;
         pA0 += incAk;
         rC0_0 += m0;
         rC0_0 += m1;
         rC0_0 += m2;
         rC0_0 += m3;
         rC0_0 += m4;
         rC0_0 += m5;
         pB0 += incBk;
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK0x0x36NN0x0x0_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=0, NB=0, KB=36, 
 * lda=0, ldb=0, ldc=0, mu=12, nu=1, ku=36, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   const int Mb = (M/12)*12;
   #define Nb N
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 12 - (((lda) << 5)+((lda) << 2)), incAn = -(Mb);
   #define incBk 36
   const int incBm = -36, incBn = (ldb);
   #define incAk0 incAk
   const int incBk0 = ((incBk) / 36);
   #define incCm 12
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7, rA8, rA9, rA10, rA11;
   register float rB0;
   register float m0, m1, m2, m3, m4, m5;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC8_0, rC9_0, rC10_0, rC11_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+16);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
            rC3_0 = pC0[3];
            rC3_0 *= rA0;
            rC4_0 = pC0[4];
            rC4_0 *= rA0;
            rC5_0 = pC0[5];
            rC5_0 *= rA0;
            rC6_0 = pC0[6];
            rC6_0 *= rA0;
            rC7_0 = pC0[7];
            rC7_0 *= rA0;
            rC8_0 = pC0[8];
            rC8_0 *= rA0;
            rC9_0 = pC0[9];
            rC9_0 *= rA0;
            rC10_0 = pC0[10];
            rC10_0 *= rA0;
            rC11_0 = pC0[11];
            rC11_0 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            m0 = rA0 * rB0;
            rA11 = pA0[11];
            m1 = rA1 * rB0;
            m2 = rA2 * rB0;
            m3 = rA3 * rB0;
            m4 = rA4 * rB0;
            m5 = rA5 * rB0;

/*
 *          Completely unrolled K-loop
 */
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[5];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[7];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[8];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[9];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[10];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[11];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[12];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[13];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[14];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[15];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[16];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[17];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[18];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[19];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[20];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[21];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[22];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[23];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[24];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[25];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[26];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[27];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[28];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[29];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[30];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[31];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[32];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[33];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[34];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[35];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rA10 = pA0[10];
            rA11 = pA0[11];
            rC6_0 += m0;
            m0 = rA0 * rB0;
            rC7_0 += m1;
            m1 = rA1 * rB0;
            rC8_0 += m2;
            m2 = rA2 * rB0;
            rC9_0 += m3;
            m3 = rA3 * rB0;
            rC10_0 += m4;
            m4 = rA4 * rB0;
            rC11_0 += m5;
            m5 = rA5 * rB0;
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA6 * rB0;
            rC1_0 += m1;
            m1 = rA7 * rB0;
            rC2_0 += m2;
            m2 = rA8 * rB0;
            rC3_0 += m3;
            m3 = rA9 * rB0;
            rC4_0 += m4;
            m4 = rA10 * rB0;
            rC5_0 += m5;
            m5 = rA11 * rB0;
            pA0 += incAk;
            rC6_0 += m0;
            rC7_0 += m1;
            rC8_0 += m2;
            rC9_0 += m3;
            rC10_0 += m4;
            rC11_0 += m5;
            pB0 += incBk;
            rB0 = alpha;
            rC0_0 *= rB0;
            rC1_0 *= rB0;
            rC2_0 *= rB0;
            rC3_0 *= rB0;
            rC4_0 *= rB0;
            rC5_0 *= rB0;
            rC6_0 *= rB0;
            rC7_0 *= rB0;
            rC8_0 *= rB0;
            rC9_0 *= rB0;
            rC10_0 *= rB0;
            rC11_0 *= rB0;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0[4] = rC4_0;
            pC0[5] = rC5_0;
            pC0[6] = rC6_0;
            pC0[7] = rC7_0;
            pC0[8] = rC8_0;
            pC0[9] = rC9_0;
            pC0[10] = rC10_0;
            pC0[11] = rC11_0;
            pC0 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_sJIK0x0x36NN1x1x36_aX_bX(k, N, 36, alpha, ca + (Mb), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
