#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x0TN1x1x1_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=1, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   #define Mb M
   #define Nb N
   #define Kb K
   const float *stM = A + (lda*Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 1
   const int incAm = ((lda) - Kb), incAn = -(Mb*lda);
   #define incBk 1
   const int incBm = -(Kb), incBn = (ldb);
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float rC0_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=0; k < K; k++) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x0TN1x1x18_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=18, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   #define Mb M
   #define Nb N
   #define Kb K
   const int Kloop = ((K-2)/18)*18, kr = K - Kloop - 2;
   const float *stM = A + (lda*Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 18
   const int incAm = ((lda) - Kb), incAn = -(Mb*lda);
   #define incBk 18
   const int incBm = -(Kb), incBn = (ldb);
   const int incAk0 = ((incAk) / 18), incBk0 = ((incBk) / 18);
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float m0;
   register float rC0_0;
   if (K < 3)
   {
      ATL_sJIK0x0x0TN1x1x1_aX_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
      return;
   }
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];

         pA0 += (incAk0);
         pB0 += (incBk0);
         for (k=0; k < Kloop; k += 18) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[17];
            rB0 = pB0[17];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[18];
            rB0 = pB0[18];
            pA0 += incAk;
            pB0 += incBk;
         } /* end K-loop */
         switch(kr)
         {
         case 1:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            pA0 += (incAk0);
            pB0 += (incBk0);
            break;
         case 2:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            pA0 += (((incAk0) << 1));
            pB0 += (((incBk0) << 1));
            break;
         case 3:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            pA0 += (((incAk0) << 1)+incAk0);
            pB0 += (((incBk0) << 1)+incBk0);
            break;
         case 4:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            pA0 += (((incAk0) << 2));
            pB0 += (((incBk0) << 2));
            break;
         case 5:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            pA0 += (((incAk0) << 2)+incAk0);
            pB0 += (((incBk0) << 2)+incBk0);
            break;
         case 6:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            pA0 += (((incAk0) << 2)+((incAk0) << 1));
            pB0 += (((incBk0) << 2)+((incBk0) << 1));
            break;
         case 7:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            pA0 += (7*(incAk0));
            pB0 += (7*(incBk0));
            break;
         case 8:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            pA0 += (((incAk0) << 3));
            pB0 += (((incBk0) << 3));
            break;
         case 9:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            pA0 += (((incAk0) << 3)+incAk0);
            pB0 += (((incBk0) << 3)+incBk0);
            break;
         case 10:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            pA0 += (((incAk0) << 3)+((incAk0) << 1));
            pB0 += (((incBk0) << 3)+((incBk0) << 1));
            break;
         case 11:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            pA0 += (11*(incAk0));
            pB0 += (11*(incBk0));
            break;
         case 12:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            pA0 += (((incAk0) << 3)+((incAk0) << 2));
            pB0 += (((incBk0) << 3)+((incBk0) << 2));
            break;
         case 13:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            pA0 += (13*(incAk0));
            pB0 += (13*(incBk0));
            break;
         case 14:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            pA0 += (14*(incAk0));
            pB0 += (14*(incBk0));
            break;
         case 15:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[15];
            rB0 = pB0[15];
            pA0 += (15*(incAk0));
            pB0 += (15*(incBk0));
            break;
         case 16:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[16];
            rB0 = pB0[16];
            pA0 += (((incAk0) << 4));
            pB0 += (((incBk0) << 4));
            break;
         case 17:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[17];
            rB0 = pB0[17];
            pA0 += (((incAk0) << 4)+incAk0);
            pB0 += (((incBk0) << 4)+incBk0);
            break;
         case 0: ;
         }
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         pA0 += incAk0;
         pB0 += incBk0;
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK0x0x0TN0x0x0_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=12, nu=1, ku=18, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   const int Mb = (M/12)*12;
   #define Nb N
   #define Kb K
   const int Kloop = ((K-1)/18)*18, kr = K - Kloop - 1;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (lda*Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 18
   const int incAm = ((((lda) << 3)+((lda) << 2)) - Kb), incAn = -(Mb*lda);
   #define incBk 18
   const int incBm = -(Kb), incBn = (ldb);
   const int incAk0 = ((incAk) / 18), incBk0 = ((incBk) / 18);
   #define incCm 12
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda), *pA4=pA3+(lda), *pA5=pA4+(lda), *pA6=pA5+(lda), *pA7=pA6+(lda), *pA8=pA7+(lda), *pA9=pA8+(lda), *pA10=pA9+(lda), *pA11=pA10+(lda);
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7, rA8, rA9, rA10, rA11;
   register float rB0;
   register float m0;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC8_0, rC9_0, rC10_0, rC11_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+16);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
            rC3_0 = pC0[3];
            rC3_0 *= rA0;
            rC4_0 = pC0[4];
            rC4_0 *= rA0;
            rC5_0 = pC0[5];
            rC5_0 *= rA0;
            rC6_0 = pC0[6];
            rC6_0 *= rA0;
            rC7_0 = pC0[7];
            rC7_0 *= rA0;
            rC8_0 = pC0[8];
            rC8_0 *= rA0;
            rC9_0 = pC0[9];
            rC9_0 *= rA0;
            rC10_0 = pC0[10];
            rC10_0 *= rA0;
            rC11_0 = pC0[11];
            rC11_0 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = *pA1;
            rA2 = *pA2;
            rA3 = *pA3;
            rA4 = *pA4;
            rA5 = *pA5;
            rA6 = *pA6;
            rA7 = *pA7;
            rA8 = *pA8;
            rA9 = *pA9;
            rA10 = *pA10;
            m0 = rA0 * rB0;
            rA11 = *pA11;

            for (k=0; k < Kloop; k += 18) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rA4 = pA4[1];
               rA5 = pA5[1];
               rA6 = pA6[1];
               rA7 = pA7[1];
               rA8 = pA8[1];
               rA9 = pA9[1];
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rA6 = pA6[2];
               rA7 = pA7[2];
               rA8 = pA8[2];
               rA9 = pA9[2];
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rA4 = pA4[3];
               rA5 = pA5[3];
               rA6 = pA6[3];
               rA7 = pA7[3];
               rA8 = pA8[3];
               rA9 = pA9[3];
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rA6 = pA6[4];
               rA7 = pA7[4];
               rA8 = pA8[4];
               rA9 = pA9[4];
               rA10 = pA10[4];
               rA11 = pA11[4];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rA3 = pA3[5];
               rA4 = pA4[5];
               rA5 = pA5[5];
               rA6 = pA6[5];
               rA7 = pA7[5];
               rA8 = pA8[5];
               rA9 = pA9[5];
               rA10 = pA10[5];
               rA11 = pA11[5];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rA4 = pA4[6];
               rA5 = pA5[6];
               rA6 = pA6[6];
               rA7 = pA7[6];
               rA8 = pA8[6];
               rA9 = pA9[6];
               rA10 = pA10[6];
               rA11 = pA11[6];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rA3 = pA3[7];
               rA4 = pA4[7];
               rA5 = pA5[7];
               rA6 = pA6[7];
               rA7 = pA7[7];
               rA8 = pA8[7];
               rA9 = pA9[7];
               rA10 = pA10[7];
               rA11 = pA11[7];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rA4 = pA4[8];
               rA5 = pA5[8];
               rA6 = pA6[8];
               rA7 = pA7[8];
               rA8 = pA8[8];
               rA9 = pA9[8];
               rA10 = pA10[8];
               rA11 = pA11[8];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rA3 = pA3[9];
               rA4 = pA4[9];
               rA5 = pA5[9];
               rA6 = pA6[9];
               rA7 = pA7[9];
               rA8 = pA8[9];
               rA9 = pA9[9];
               rA10 = pA10[9];
               rA11 = pA11[9];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rA3 = pA3[10];
               rA4 = pA4[10];
               rA5 = pA5[10];
               rA6 = pA6[10];
               rA7 = pA7[10];
               rA8 = pA8[10];
               rA9 = pA9[10];
               rA10 = pA10[10];
               rA11 = pA11[10];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               rA3 = pA3[11];
               rA4 = pA4[11];
               rA5 = pA5[11];
               rA6 = pA6[11];
               rA7 = pA7[11];
               rA8 = pA8[11];
               rA9 = pA9[11];
               rA10 = pA10[11];
               rA11 = pA11[11];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rA2 = pA2[12];
               rA3 = pA3[12];
               rA4 = pA4[12];
               rA5 = pA5[12];
               rA6 = pA6[12];
               rA7 = pA7[12];
               rA8 = pA8[12];
               rA9 = pA9[12];
               rA10 = pA10[12];
               rA11 = pA11[12];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[13];
               rB0 = pB0[13];
               rA1 = pA1[13];
               rA2 = pA2[13];
               rA3 = pA3[13];
               rA4 = pA4[13];
               rA5 = pA5[13];
               rA6 = pA6[13];
               rA7 = pA7[13];
               rA8 = pA8[13];
               rA9 = pA9[13];
               rA10 = pA10[13];
               rA11 = pA11[13];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rA1 = pA1[14];
               rA2 = pA2[14];
               rA3 = pA3[14];
               rA4 = pA4[14];
               rA5 = pA5[14];
               rA6 = pA6[14];
               rA7 = pA7[14];
               rA8 = pA8[14];
               rA9 = pA9[14];
               rA10 = pA10[14];
               rA11 = pA11[14];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[15];
               rB0 = pB0[15];
               rA1 = pA1[15];
               rA2 = pA2[15];
               rA3 = pA3[15];
               rA4 = pA4[15];
               rA5 = pA5[15];
               rA6 = pA6[15];
               rA7 = pA7[15];
               rA8 = pA8[15];
               rA9 = pA9[15];
               rA10 = pA10[15];
               rA11 = pA11[15];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[16];
               rB0 = pB0[16];
               rA1 = pA1[16];
               rA2 = pA2[16];
               rA3 = pA3[16];
               rA4 = pA4[16];
               rA5 = pA5[16];
               rA6 = pA6[16];
               rA7 = pA7[16];
               rA8 = pA8[16];
               rA9 = pA9[16];
               rA10 = pA10[16];
               rA11 = pA11[16];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[17];
               rB0 = pB0[17];
               rA1 = pA1[17];
               rA2 = pA2[17];
               rA3 = pA3[17];
               rA4 = pA4[17];
               rA5 = pA5[17];
               rA6 = pA6[17];
               rA7 = pA7[17];
               rA8 = pA8[17];
               rA9 = pA9[17];
               rA10 = pA10[17];
               rA11 = pA11[17];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[18];
               rB0 = pB0[18];
               rA1 = pA1[18];
               rA2 = pA2[18];
               rA3 = pA3[18];
               rA4 = pA4[18];
               rA5 = pA5[18];
               rA6 = pA6[18];
               rA7 = pA7[18];
               rA8 = pA8[18];
               rA9 = pA9[18];
               rA10 = pA10[18];
               rA11 = pA11[18];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               pA0 += incAk;
               pA1 += incAk;
               pA2 += incAk;
               pA3 += incAk;
               pA4 += incAk;
               pA5 += incAk;
               pA6 += incAk;
               pA7 += incAk;
               pA8 += incAk;
               pA9 += incAk;
               pA10 += incAk;
               pA11 += incAk;
               pB0 += incBk;
            } /* end K-loop */
            switch(kr)
            {
            case 1:
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rA4 = pA4[1];
               rA5 = pA5[1];
               rA6 = pA6[1];
               rA7 = pA7[1];
               rA8 = pA8[1];
               rA9 = pA9[1];
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               pA0 += (incAk0);
               pA1 += (incAk0);
               pA2 += (incAk0);
               pA3 += (incAk0);
               pA4 += (incAk0);
               pA5 += (incAk0);
               pA6 += (incAk0);
               pA7 += (incAk0);
               pA8 += (incAk0);
               pA9 += (incAk0);
               pA10 += (incAk0);
               pA11 += (incAk0);
               pB0 += (incBk0);
               break;
            case 2:
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rA4 = pA4[1];
               rA5 = pA5[1];
               rA6 = pA6[1];
               rA7 = pA7[1];
               rA8 = pA8[1];
               rA9 = pA9[1];
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rA6 = pA6[2];
               rA7 = pA7[2];
               rA8 = pA8[2];
               rA9 = pA9[2];
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               pA0 += (((incAk0) << 1));
               pA1 += (((incAk0) << 1));
               pA2 += (((incAk0) << 1));
               pA3 += (((incAk0) << 1));
               pA4 += (((incAk0) << 1));
               pA5 += (((incAk0) << 1));
               pA6 += (((incAk0) << 1));
               pA7 += (((incAk0) << 1));
               pA8 += (((incAk0) << 1));
               pA9 += (((incAk0) << 1));
               pA10 += (((incAk0) << 1));
               pA11 += (((incAk0) << 1));
               pB0 += (((incBk0) << 1));
               break;
            case 3:
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rA4 = pA4[1];
               rA5 = pA5[1];
               rA6 = pA6[1];
               rA7 = pA7[1];
               rA8 = pA8[1];
               rA9 = pA9[1];
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rA6 = pA6[2];
               rA7 = pA7[2];
               rA8 = pA8[2];
               rA9 = pA9[2];
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rA4 = pA4[3];
               rA5 = pA5[3];
               rA6 = pA6[3];
               rA7 = pA7[3];
               rA8 = pA8[3];
               rA9 = pA9[3];
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               pA0 += (((incAk0) << 1)+incAk0);
               pA1 += (((incAk0) << 1)+incAk0);
               pA2 += (((incAk0) << 1)+incAk0);
               pA3 += (((incAk0) << 1)+incAk0);
               pA4 += (((incAk0) << 1)+incAk0);
               pA5 += (((incAk0) << 1)+incAk0);
               pA6 += (((incAk0) << 1)+incAk0);
               pA7 += (((incAk0) << 1)+incAk0);
               pA8 += (((incAk0) << 1)+incAk0);
               pA9 += (((incAk0) << 1)+incAk0);
               pA10 += (((incAk0) << 1)+incAk0);
               pA11 += (((incAk0) << 1)+incAk0);
               pB0 += (((incBk0) << 1)+incBk0);
               break;
            case 4:
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rA4 = pA4[1];
               rA5 = pA5[1];
               rA6 = pA6[1];
               rA7 = pA7[1];
               rA8 = pA8[1];
               rA9 = pA9[1];
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rA6 = pA6[2];
               rA7 = pA7[2];
               rA8 = pA8[2];
               rA9 = pA9[2];
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rA4 = pA4[3];
               rA5 = pA5[3];
               rA6 = pA6[3];
               rA7 = pA7[3];
               rA8 = pA8[3];
               rA9 = pA9[3];
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rA6 = pA6[4];
               rA7 = pA7[4];
               rA8 = pA8[4];
               rA9 = pA9[4];
               rA10 = pA10[4];
               rA11 = pA11[4];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               pA0 += (((incAk0) << 2));
               pA1 += (((incAk0) << 2));
               pA2 += (((incAk0) << 2));
               pA3 += (((incAk0) << 2));
               pA4 += (((incAk0) << 2));
               pA5 += (((incAk0) << 2));
               pA6 += (((incAk0) << 2));
               pA7 += (((incAk0) << 2));
               pA8 += (((incAk0) << 2));
               pA9 += (((incAk0) << 2));
               pA10 += (((incAk0) << 2));
               pA11 += (((incAk0) << 2));
               pB0 += (((incBk0) << 2));
               break;
            case 5:
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rA4 = pA4[1];
               rA5 = pA5[1];
               rA6 = pA6[1];
               rA7 = pA7[1];
               rA8 = pA8[1];
               rA9 = pA9[1];
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rA6 = pA6[2];
               rA7 = pA7[2];
               rA8 = pA8[2];
               rA9 = pA9[2];
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rA4 = pA4[3];
               rA5 = pA5[3];
               rA6 = pA6[3];
               rA7 = pA7[3];
               rA8 = pA8[3];
               rA9 = pA9[3];
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rA6 = pA6[4];
               rA7 = pA7[4];
               rA8 = pA8[4];
               rA9 = pA9[4];
               rA10 = pA10[4];
               rA11 = pA11[4];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rA3 = pA3[5];
               rA4 = pA4[5];
               rA5 = pA5[5];
               rA6 = pA6[5];
               rA7 = pA7[5];
               rA8 = pA8[5];
               rA9 = pA9[5];
               rA10 = pA10[5];
               rA11 = pA11[5];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               pA0 += (((incAk0) << 2)+incAk0);
               pA1 += (((incAk0) << 2)+incAk0);
               pA2 += (((incAk0) << 2)+incAk0);
               pA3 += (((incAk0) << 2)+incAk0);
               pA4 += (((incAk0) << 2)+incAk0);
               pA5 += (((incAk0) << 2)+incAk0);
               pA6 += (((incAk0) << 2)+incAk0);
               pA7 += (((incAk0) << 2)+incAk0);
               pA8 += (((incAk0) << 2)+incAk0);
               pA9 += (((incAk0) << 2)+incAk0);
               pA10 += (((incAk0) << 2)+incAk0);
               pA11 += (((incAk0) << 2)+incAk0);
               pB0 += (((incBk0) << 2)+incBk0);
               break;
            case 6:
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rA4 = pA4[1];
               rA5 = pA5[1];
               rA6 = pA6[1];
               rA7 = pA7[1];
               rA8 = pA8[1];
               rA9 = pA9[1];
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rA6 = pA6[2];
               rA7 = pA7[2];
               rA8 = pA8[2];
               rA9 = pA9[2];
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rA4 = pA4[3];
               rA5 = pA5[3];
               rA6 = pA6[3];
               rA7 = pA7[3];
               rA8 = pA8[3];
               rA9 = pA9[3];
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rA6 = pA6[4];
               rA7 = pA7[4];
               rA8 = pA8[4];
               rA9 = pA9[4];
               rA10 = pA10[4];
               rA11 = pA11[4];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rA3 = pA3[5];
               rA4 = pA4[5];
               rA5 = pA5[5];
               rA6 = pA6[5];
               rA7 = pA7[5];
               rA8 = pA8[5];
               rA9 = pA9[5];
               rA10 = pA10[5];
               rA11 = pA11[5];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rA4 = pA4[6];
               rA5 = pA5[6];
               rA6 = pA6[6];
               rA7 = pA7[6];
               rA8 = pA8[6];
               rA9 = pA9[6];
               rA10 = pA10[6];
               rA11 = pA11[6];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               pA0 += (((incAk0) << 2)+((incAk0) << 1));
               pA1 += (((incAk0) << 2)+((incAk0) << 1));
               pA2 += (((incAk0) << 2)+((incAk0) << 1));
               pA3 += (((incAk0) << 2)+((incAk0) << 1));
               pA4 += (((incAk0) << 2)+((incAk0) << 1));
               pA5 += (((incAk0) << 2)+((incAk0) << 1));
               pA6 += (((incAk0) << 2)+((incAk0) << 1));
               pA7 += (((incAk0) << 2)+((incAk0) << 1));
               pA8 += (((incAk0) << 2)+((incAk0) << 1));
               pA9 += (((incAk0) << 2)+((incAk0) << 1));
               pA10 += (((incAk0) << 2)+((incAk0) << 1));
               pA11 += (((incAk0) << 2)+((incAk0) << 1));
               pB0 += (((incBk0) << 2)+((incBk0) << 1));
               break;
            case 7:
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rA4 = pA4[1];
               rA5 = pA5[1];
               rA6 = pA6[1];
               rA7 = pA7[1];
               rA8 = pA8[1];
               rA9 = pA9[1];
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rA6 = pA6[2];
               rA7 = pA7[2];
               rA8 = pA8[2];
               rA9 = pA9[2];
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rA4 = pA4[3];
               rA5 = pA5[3];
               rA6 = pA6[3];
               rA7 = pA7[3];
               rA8 = pA8[3];
               rA9 = pA9[3];
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rA6 = pA6[4];
               rA7 = pA7[4];
               rA8 = pA8[4];
               rA9 = pA9[4];
               rA10 = pA10[4];
               rA11 = pA11[4];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rA3 = pA3[5];
               rA4 = pA4[5];
               rA5 = pA5[5];
               rA6 = pA6[5];
               rA7 = pA7[5];
               rA8 = pA8[5];
               rA9 = pA9[5];
               rA10 = pA10[5];
               rA11 = pA11[5];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rA4 = pA4[6];
               rA5 = pA5[6];
               rA6 = pA6[6];
               rA7 = pA7[6];
               rA8 = pA8[6];
               rA9 = pA9[6];
               rA10 = pA10[6];
               rA11 = pA11[6];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rA3 = pA3[7];
               rA4 = pA4[7];
               rA5 = pA5[7];
               rA6 = pA6[7];
               rA7 = pA7[7];
               rA8 = pA8[7];
               rA9 = pA9[7];
               rA10 = pA10[7];
               rA11 = pA11[7];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               pA0 += (7*(incAk0));
               pA1 += (7*(incAk0));
               pA2 += (7*(incAk0));
               pA3 += (7*(incAk0));
               pA4 += (7*(incAk0));
               pA5 += (7*(incAk0));
               pA6 += (7*(incAk0));
               pA7 += (7*(incAk0));
               pA8 += (7*(incAk0));
               pA9 += (7*(incAk0));
               pA10 += (7*(incAk0));
               pA11 += (7*(incAk0));
               pB0 += (7*(incBk0));
               break;
            case 8:
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rA4 = pA4[1];
               rA5 = pA5[1];
               rA6 = pA6[1];
               rA7 = pA7[1];
               rA8 = pA8[1];
               rA9 = pA9[1];
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rA6 = pA6[2];
               rA7 = pA7[2];
               rA8 = pA8[2];
               rA9 = pA9[2];
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rA4 = pA4[3];
               rA5 = pA5[3];
               rA6 = pA6[3];
               rA7 = pA7[3];
               rA8 = pA8[3];
               rA9 = pA9[3];
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rA6 = pA6[4];
               rA7 = pA7[4];
               rA8 = pA8[4];
               rA9 = pA9[4];
               rA10 = pA10[4];
               rA11 = pA11[4];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rA3 = pA3[5];
               rA4 = pA4[5];
               rA5 = pA5[5];
               rA6 = pA6[5];
               rA7 = pA7[5];
               rA8 = pA8[5];
               rA9 = pA9[5];
               rA10 = pA10[5];
               rA11 = pA11[5];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rA4 = pA4[6];
               rA5 = pA5[6];
               rA6 = pA6[6];
               rA7 = pA7[6];
               rA8 = pA8[6];
               rA9 = pA9[6];
               rA10 = pA10[6];
               rA11 = pA11[6];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rA3 = pA3[7];
               rA4 = pA4[7];
               rA5 = pA5[7];
               rA6 = pA6[7];
               rA7 = pA7[7];
               rA8 = pA8[7];
               rA9 = pA9[7];
               rA10 = pA10[7];
               rA11 = pA11[7];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rA4 = pA4[8];
               rA5 = pA5[8];
               rA6 = pA6[8];
               rA7 = pA7[8];
               rA8 = pA8[8];
               rA9 = pA9[8];
               rA10 = pA10[8];
               rA11 = pA11[8];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               pA0 += (((incAk0) << 3));
               pA1 += (((incAk0) << 3));
               pA2 += (((incAk0) << 3));
               pA3 += (((incAk0) << 3));
               pA4 += (((incAk0) << 3));
               pA5 += (((incAk0) << 3));
               pA6 += (((incAk0) << 3));
               pA7 += (((incAk0) << 3));
               pA8 += (((incAk0) << 3));
               pA9 += (((incAk0) << 3));
               pA10 += (((incAk0) << 3));
               pA11 += (((incAk0) << 3));
               pB0 += (((incBk0) << 3));
               break;
            case 9:
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rA4 = pA4[1];
               rA5 = pA5[1];
               rA6 = pA6[1];
               rA7 = pA7[1];
               rA8 = pA8[1];
               rA9 = pA9[1];
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rA6 = pA6[2];
               rA7 = pA7[2];
               rA8 = pA8[2];
               rA9 = pA9[2];
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rA4 = pA4[3];
               rA5 = pA5[3];
               rA6 = pA6[3];
               rA7 = pA7[3];
               rA8 = pA8[3];
               rA9 = pA9[3];
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rA6 = pA6[4];
               rA7 = pA7[4];
               rA8 = pA8[4];
               rA9 = pA9[4];
               rA10 = pA10[4];
               rA11 = pA11[4];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rA3 = pA3[5];
               rA4 = pA4[5];
               rA5 = pA5[5];
               rA6 = pA6[5];
               rA7 = pA7[5];
               rA8 = pA8[5];
               rA9 = pA9[5];
               rA10 = pA10[5];
               rA11 = pA11[5];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rA4 = pA4[6];
               rA5 = pA5[6];
               rA6 = pA6[6];
               rA7 = pA7[6];
               rA8 = pA8[6];
               rA9 = pA9[6];
               rA10 = pA10[6];
               rA11 = pA11[6];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rA3 = pA3[7];
               rA4 = pA4[7];
               rA5 = pA5[7];
               rA6 = pA6[7];
               rA7 = pA7[7];
               rA8 = pA8[7];
               rA9 = pA9[7];
               rA10 = pA10[7];
               rA11 = pA11[7];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rA4 = pA4[8];
               rA5 = pA5[8];
               rA6 = pA6[8];
               rA7 = pA7[8];
               rA8 = pA8[8];
               rA9 = pA9[8];
               rA10 = pA10[8];
               rA11 = pA11[8];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rA3 = pA3[9];
               rA4 = pA4[9];
               rA5 = pA5[9];
               rA6 = pA6[9];
               rA7 = pA7[9];
               rA8 = pA8[9];
               rA9 = pA9[9];
               rA10 = pA10[9];
               rA11 = pA11[9];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               pA0 += (((incAk0) << 3)+incAk0);
               pA1 += (((incAk0) << 3)+incAk0);
               pA2 += (((incAk0) << 3)+incAk0);
               pA3 += (((incAk0) << 3)+incAk0);
               pA4 += (((incAk0) << 3)+incAk0);
               pA5 += (((incAk0) << 3)+incAk0);
               pA6 += (((incAk0) << 3)+incAk0);
               pA7 += (((incAk0) << 3)+incAk0);
               pA8 += (((incAk0) << 3)+incAk0);
               pA9 += (((incAk0) << 3)+incAk0);
               pA10 += (((incAk0) << 3)+incAk0);
               pA11 += (((incAk0) << 3)+incAk0);
               pB0 += (((incBk0) << 3)+incBk0);
               break;
            case 10:
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rA4 = pA4[1];
               rA5 = pA5[1];
               rA6 = pA6[1];
               rA7 = pA7[1];
               rA8 = pA8[1];
               rA9 = pA9[1];
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rA6 = pA6[2];
               rA7 = pA7[2];
               rA8 = pA8[2];
               rA9 = pA9[2];
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rA4 = pA4[3];
               rA5 = pA5[3];
               rA6 = pA6[3];
               rA7 = pA7[3];
               rA8 = pA8[3];
               rA9 = pA9[3];
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rA6 = pA6[4];
               rA7 = pA7[4];
               rA8 = pA8[4];
               rA9 = pA9[4];
               rA10 = pA10[4];
               rA11 = pA11[4];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rA3 = pA3[5];
               rA4 = pA4[5];
               rA5 = pA5[5];
               rA6 = pA6[5];
               rA7 = pA7[5];
               rA8 = pA8[5];
               rA9 = pA9[5];
               rA10 = pA10[5];
               rA11 = pA11[5];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rA4 = pA4[6];
               rA5 = pA5[6];
               rA6 = pA6[6];
               rA7 = pA7[6];
               rA8 = pA8[6];
               rA9 = pA9[6];
               rA10 = pA10[6];
               rA11 = pA11[6];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rA3 = pA3[7];
               rA4 = pA4[7];
               rA5 = pA5[7];
               rA6 = pA6[7];
               rA7 = pA7[7];
               rA8 = pA8[7];
               rA9 = pA9[7];
               rA10 = pA10[7];
               rA11 = pA11[7];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rA4 = pA4[8];
               rA5 = pA5[8];
               rA6 = pA6[8];
               rA7 = pA7[8];
               rA8 = pA8[8];
               rA9 = pA9[8];
               rA10 = pA10[8];
               rA11 = pA11[8];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rA3 = pA3[9];
               rA4 = pA4[9];
               rA5 = pA5[9];
               rA6 = pA6[9];
               rA7 = pA7[9];
               rA8 = pA8[9];
               rA9 = pA9[9];
               rA10 = pA10[9];
               rA11 = pA11[9];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rA3 = pA3[10];
               rA4 = pA4[10];
               rA5 = pA5[10];
               rA6 = pA6[10];
               rA7 = pA7[10];
               rA8 = pA8[10];
               rA9 = pA9[10];
               rA10 = pA10[10];
               rA11 = pA11[10];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               pA0 += (((incAk0) << 3)+((incAk0) << 1));
               pA1 += (((incAk0) << 3)+((incAk0) << 1));
               pA2 += (((incAk0) << 3)+((incAk0) << 1));
               pA3 += (((incAk0) << 3)+((incAk0) << 1));
               pA4 += (((incAk0) << 3)+((incAk0) << 1));
               pA5 += (((incAk0) << 3)+((incAk0) << 1));
               pA6 += (((incAk0) << 3)+((incAk0) << 1));
               pA7 += (((incAk0) << 3)+((incAk0) << 1));
               pA8 += (((incAk0) << 3)+((incAk0) << 1));
               pA9 += (((incAk0) << 3)+((incAk0) << 1));
               pA10 += (((incAk0) << 3)+((incAk0) << 1));
               pA11 += (((incAk0) << 3)+((incAk0) << 1));
               pB0 += (((incBk0) << 3)+((incBk0) << 1));
               break;
            case 11:
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rA4 = pA4[1];
               rA5 = pA5[1];
               rA6 = pA6[1];
               rA7 = pA7[1];
               rA8 = pA8[1];
               rA9 = pA9[1];
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rA6 = pA6[2];
               rA7 = pA7[2];
               rA8 = pA8[2];
               rA9 = pA9[2];
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rA4 = pA4[3];
               rA5 = pA5[3];
               rA6 = pA6[3];
               rA7 = pA7[3];
               rA8 = pA8[3];
               rA9 = pA9[3];
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rA6 = pA6[4];
               rA7 = pA7[4];
               rA8 = pA8[4];
               rA9 = pA9[4];
               rA10 = pA10[4];
               rA11 = pA11[4];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rA3 = pA3[5];
               rA4 = pA4[5];
               rA5 = pA5[5];
               rA6 = pA6[5];
               rA7 = pA7[5];
               rA8 = pA8[5];
               rA9 = pA9[5];
               rA10 = pA10[5];
               rA11 = pA11[5];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rA4 = pA4[6];
               rA5 = pA5[6];
               rA6 = pA6[6];
               rA7 = pA7[6];
               rA8 = pA8[6];
               rA9 = pA9[6];
               rA10 = pA10[6];
               rA11 = pA11[6];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rA3 = pA3[7];
               rA4 = pA4[7];
               rA5 = pA5[7];
               rA6 = pA6[7];
               rA7 = pA7[7];
               rA8 = pA8[7];
               rA9 = pA9[7];
               rA10 = pA10[7];
               rA11 = pA11[7];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rA4 = pA4[8];
               rA5 = pA5[8];
               rA6 = pA6[8];
               rA7 = pA7[8];
               rA8 = pA8[8];
               rA9 = pA9[8];
               rA10 = pA10[8];
               rA11 = pA11[8];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rA3 = pA3[9];
               rA4 = pA4[9];
               rA5 = pA5[9];
               rA6 = pA6[9];
               rA7 = pA7[9];
               rA8 = pA8[9];
               rA9 = pA9[9];
               rA10 = pA10[9];
               rA11 = pA11[9];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rA3 = pA3[10];
               rA4 = pA4[10];
               rA5 = pA5[10];
               rA6 = pA6[10];
               rA7 = pA7[10];
               rA8 = pA8[10];
               rA9 = pA9[10];
               rA10 = pA10[10];
               rA11 = pA11[10];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               rA3 = pA3[11];
               rA4 = pA4[11];
               rA5 = pA5[11];
               rA6 = pA6[11];
               rA7 = pA7[11];
               rA8 = pA8[11];
               rA9 = pA9[11];
               rA10 = pA10[11];
               rA11 = pA11[11];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               pA0 += (11*(incAk0));
               pA1 += (11*(incAk0));
               pA2 += (11*(incAk0));
               pA3 += (11*(incAk0));
               pA4 += (11*(incAk0));
               pA5 += (11*(incAk0));
               pA6 += (11*(incAk0));
               pA7 += (11*(incAk0));
               pA8 += (11*(incAk0));
               pA9 += (11*(incAk0));
               pA10 += (11*(incAk0));
               pA11 += (11*(incAk0));
               pB0 += (11*(incBk0));
               break;
            case 12:
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rA4 = pA4[1];
               rA5 = pA5[1];
               rA6 = pA6[1];
               rA7 = pA7[1];
               rA8 = pA8[1];
               rA9 = pA9[1];
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rA6 = pA6[2];
               rA7 = pA7[2];
               rA8 = pA8[2];
               rA9 = pA9[2];
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rA4 = pA4[3];
               rA5 = pA5[3];
               rA6 = pA6[3];
               rA7 = pA7[3];
               rA8 = pA8[3];
               rA9 = pA9[3];
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rA6 = pA6[4];
               rA7 = pA7[4];
               rA8 = pA8[4];
               rA9 = pA9[4];
               rA10 = pA10[4];
               rA11 = pA11[4];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rA3 = pA3[5];
               rA4 = pA4[5];
               rA5 = pA5[5];
               rA6 = pA6[5];
               rA7 = pA7[5];
               rA8 = pA8[5];
               rA9 = pA9[5];
               rA10 = pA10[5];
               rA11 = pA11[5];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rA4 = pA4[6];
               rA5 = pA5[6];
               rA6 = pA6[6];
               rA7 = pA7[6];
               rA8 = pA8[6];
               rA9 = pA9[6];
               rA10 = pA10[6];
               rA11 = pA11[6];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rA3 = pA3[7];
               rA4 = pA4[7];
               rA5 = pA5[7];
               rA6 = pA6[7];
               rA7 = pA7[7];
               rA8 = pA8[7];
               rA9 = pA9[7];
               rA10 = pA10[7];
               rA11 = pA11[7];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rA4 = pA4[8];
               rA5 = pA5[8];
               rA6 = pA6[8];
               rA7 = pA7[8];
               rA8 = pA8[8];
               rA9 = pA9[8];
               rA10 = pA10[8];
               rA11 = pA11[8];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rA3 = pA3[9];
               rA4 = pA4[9];
               rA5 = pA5[9];
               rA6 = pA6[9];
               rA7 = pA7[9];
               rA8 = pA8[9];
               rA9 = pA9[9];
               rA10 = pA10[9];
               rA11 = pA11[9];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rA3 = pA3[10];
               rA4 = pA4[10];
               rA5 = pA5[10];
               rA6 = pA6[10];
               rA7 = pA7[10];
               rA8 = pA8[10];
               rA9 = pA9[10];
               rA10 = pA10[10];
               rA11 = pA11[10];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               rA3 = pA3[11];
               rA4 = pA4[11];
               rA5 = pA5[11];
               rA6 = pA6[11];
               rA7 = pA7[11];
               rA8 = pA8[11];
               rA9 = pA9[11];
               rA10 = pA10[11];
               rA11 = pA11[11];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rA2 = pA2[12];
               rA3 = pA3[12];
               rA4 = pA4[12];
               rA5 = pA5[12];
               rA6 = pA6[12];
               rA7 = pA7[12];
               rA8 = pA8[12];
               rA9 = pA9[12];
               rA10 = pA10[12];
               rA11 = pA11[12];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               pA0 += (((incAk0) << 3)+((incAk0) << 2));
               pA1 += (((incAk0) << 3)+((incAk0) << 2));
               pA2 += (((incAk0) << 3)+((incAk0) << 2));
               pA3 += (((incAk0) << 3)+((incAk0) << 2));
               pA4 += (((incAk0) << 3)+((incAk0) << 2));
               pA5 += (((incAk0) << 3)+((incAk0) << 2));
               pA6 += (((incAk0) << 3)+((incAk0) << 2));
               pA7 += (((incAk0) << 3)+((incAk0) << 2));
               pA8 += (((incAk0) << 3)+((incAk0) << 2));
               pA9 += (((incAk0) << 3)+((incAk0) << 2));
               pA10 += (((incAk0) << 3)+((incAk0) << 2));
               pA11 += (((incAk0) << 3)+((incAk0) << 2));
               pB0 += (((incBk0) << 3)+((incBk0) << 2));
               break;
            case 13:
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rA4 = pA4[1];
               rA5 = pA5[1];
               rA6 = pA6[1];
               rA7 = pA7[1];
               rA8 = pA8[1];
               rA9 = pA9[1];
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rA6 = pA6[2];
               rA7 = pA7[2];
               rA8 = pA8[2];
               rA9 = pA9[2];
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rA4 = pA4[3];
               rA5 = pA5[3];
               rA6 = pA6[3];
               rA7 = pA7[3];
               rA8 = pA8[3];
               rA9 = pA9[3];
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rA6 = pA6[4];
               rA7 = pA7[4];
               rA8 = pA8[4];
               rA9 = pA9[4];
               rA10 = pA10[4];
               rA11 = pA11[4];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rA3 = pA3[5];
               rA4 = pA4[5];
               rA5 = pA5[5];
               rA6 = pA6[5];
               rA7 = pA7[5];
               rA8 = pA8[5];
               rA9 = pA9[5];
               rA10 = pA10[5];
               rA11 = pA11[5];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rA4 = pA4[6];
               rA5 = pA5[6];
               rA6 = pA6[6];
               rA7 = pA7[6];
               rA8 = pA8[6];
               rA9 = pA9[6];
               rA10 = pA10[6];
               rA11 = pA11[6];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rA3 = pA3[7];
               rA4 = pA4[7];
               rA5 = pA5[7];
               rA6 = pA6[7];
               rA7 = pA7[7];
               rA8 = pA8[7];
               rA9 = pA9[7];
               rA10 = pA10[7];
               rA11 = pA11[7];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rA4 = pA4[8];
               rA5 = pA5[8];
               rA6 = pA6[8];
               rA7 = pA7[8];
               rA8 = pA8[8];
               rA9 = pA9[8];
               rA10 = pA10[8];
               rA11 = pA11[8];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rA3 = pA3[9];
               rA4 = pA4[9];
               rA5 = pA5[9];
               rA6 = pA6[9];
               rA7 = pA7[9];
               rA8 = pA8[9];
               rA9 = pA9[9];
               rA10 = pA10[9];
               rA11 = pA11[9];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rA3 = pA3[10];
               rA4 = pA4[10];
               rA5 = pA5[10];
               rA6 = pA6[10];
               rA7 = pA7[10];
               rA8 = pA8[10];
               rA9 = pA9[10];
               rA10 = pA10[10];
               rA11 = pA11[10];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               rA3 = pA3[11];
               rA4 = pA4[11];
               rA5 = pA5[11];
               rA6 = pA6[11];
               rA7 = pA7[11];
               rA8 = pA8[11];
               rA9 = pA9[11];
               rA10 = pA10[11];
               rA11 = pA11[11];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rA2 = pA2[12];
               rA3 = pA3[12];
               rA4 = pA4[12];
               rA5 = pA5[12];
               rA6 = pA6[12];
               rA7 = pA7[12];
               rA8 = pA8[12];
               rA9 = pA9[12];
               rA10 = pA10[12];
               rA11 = pA11[12];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[13];
               rB0 = pB0[13];
               rA1 = pA1[13];
               rA2 = pA2[13];
               rA3 = pA3[13];
               rA4 = pA4[13];
               rA5 = pA5[13];
               rA6 = pA6[13];
               rA7 = pA7[13];
               rA8 = pA8[13];
               rA9 = pA9[13];
               rA10 = pA10[13];
               rA11 = pA11[13];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               pA0 += (13*(incAk0));
               pA1 += (13*(incAk0));
               pA2 += (13*(incAk0));
               pA3 += (13*(incAk0));
               pA4 += (13*(incAk0));
               pA5 += (13*(incAk0));
               pA6 += (13*(incAk0));
               pA7 += (13*(incAk0));
               pA8 += (13*(incAk0));
               pA9 += (13*(incAk0));
               pA10 += (13*(incAk0));
               pA11 += (13*(incAk0));
               pB0 += (13*(incBk0));
               break;
            case 14:
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rA4 = pA4[1];
               rA5 = pA5[1];
               rA6 = pA6[1];
               rA7 = pA7[1];
               rA8 = pA8[1];
               rA9 = pA9[1];
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rA6 = pA6[2];
               rA7 = pA7[2];
               rA8 = pA8[2];
               rA9 = pA9[2];
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rA4 = pA4[3];
               rA5 = pA5[3];
               rA6 = pA6[3];
               rA7 = pA7[3];
               rA8 = pA8[3];
               rA9 = pA9[3];
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rA6 = pA6[4];
               rA7 = pA7[4];
               rA8 = pA8[4];
               rA9 = pA9[4];
               rA10 = pA10[4];
               rA11 = pA11[4];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rA3 = pA3[5];
               rA4 = pA4[5];
               rA5 = pA5[5];
               rA6 = pA6[5];
               rA7 = pA7[5];
               rA8 = pA8[5];
               rA9 = pA9[5];
               rA10 = pA10[5];
               rA11 = pA11[5];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rA4 = pA4[6];
               rA5 = pA5[6];
               rA6 = pA6[6];
               rA7 = pA7[6];
               rA8 = pA8[6];
               rA9 = pA9[6];
               rA10 = pA10[6];
               rA11 = pA11[6];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rA3 = pA3[7];
               rA4 = pA4[7];
               rA5 = pA5[7];
               rA6 = pA6[7];
               rA7 = pA7[7];
               rA8 = pA8[7];
               rA9 = pA9[7];
               rA10 = pA10[7];
               rA11 = pA11[7];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rA4 = pA4[8];
               rA5 = pA5[8];
               rA6 = pA6[8];
               rA7 = pA7[8];
               rA8 = pA8[8];
               rA9 = pA9[8];
               rA10 = pA10[8];
               rA11 = pA11[8];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rA3 = pA3[9];
               rA4 = pA4[9];
               rA5 = pA5[9];
               rA6 = pA6[9];
               rA7 = pA7[9];
               rA8 = pA8[9];
               rA9 = pA9[9];
               rA10 = pA10[9];
               rA11 = pA11[9];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rA3 = pA3[10];
               rA4 = pA4[10];
               rA5 = pA5[10];
               rA6 = pA6[10];
               rA7 = pA7[10];
               rA8 = pA8[10];
               rA9 = pA9[10];
               rA10 = pA10[10];
               rA11 = pA11[10];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               rA3 = pA3[11];
               rA4 = pA4[11];
               rA5 = pA5[11];
               rA6 = pA6[11];
               rA7 = pA7[11];
               rA8 = pA8[11];
               rA9 = pA9[11];
               rA10 = pA10[11];
               rA11 = pA11[11];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rA2 = pA2[12];
               rA3 = pA3[12];
               rA4 = pA4[12];
               rA5 = pA5[12];
               rA6 = pA6[12];
               rA7 = pA7[12];
               rA8 = pA8[12];
               rA9 = pA9[12];
               rA10 = pA10[12];
               rA11 = pA11[12];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[13];
               rB0 = pB0[13];
               rA1 = pA1[13];
               rA2 = pA2[13];
               rA3 = pA3[13];
               rA4 = pA4[13];
               rA5 = pA5[13];
               rA6 = pA6[13];
               rA7 = pA7[13];
               rA8 = pA8[13];
               rA9 = pA9[13];
               rA10 = pA10[13];
               rA11 = pA11[13];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rA1 = pA1[14];
               rA2 = pA2[14];
               rA3 = pA3[14];
               rA4 = pA4[14];
               rA5 = pA5[14];
               rA6 = pA6[14];
               rA7 = pA7[14];
               rA8 = pA8[14];
               rA9 = pA9[14];
               rA10 = pA10[14];
               rA11 = pA11[14];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               pA0 += (14*(incAk0));
               pA1 += (14*(incAk0));
               pA2 += (14*(incAk0));
               pA3 += (14*(incAk0));
               pA4 += (14*(incAk0));
               pA5 += (14*(incAk0));
               pA6 += (14*(incAk0));
               pA7 += (14*(incAk0));
               pA8 += (14*(incAk0));
               pA9 += (14*(incAk0));
               pA10 += (14*(incAk0));
               pA11 += (14*(incAk0));
               pB0 += (14*(incBk0));
               break;
            case 15:
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rA4 = pA4[1];
               rA5 = pA5[1];
               rA6 = pA6[1];
               rA7 = pA7[1];
               rA8 = pA8[1];
               rA9 = pA9[1];
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rA6 = pA6[2];
               rA7 = pA7[2];
               rA8 = pA8[2];
               rA9 = pA9[2];
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rA4 = pA4[3];
               rA5 = pA5[3];
               rA6 = pA6[3];
               rA7 = pA7[3];
               rA8 = pA8[3];
               rA9 = pA9[3];
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rA6 = pA6[4];
               rA7 = pA7[4];
               rA8 = pA8[4];
               rA9 = pA9[4];
               rA10 = pA10[4];
               rA11 = pA11[4];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rA3 = pA3[5];
               rA4 = pA4[5];
               rA5 = pA5[5];
               rA6 = pA6[5];
               rA7 = pA7[5];
               rA8 = pA8[5];
               rA9 = pA9[5];
               rA10 = pA10[5];
               rA11 = pA11[5];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rA4 = pA4[6];
               rA5 = pA5[6];
               rA6 = pA6[6];
               rA7 = pA7[6];
               rA8 = pA8[6];
               rA9 = pA9[6];
               rA10 = pA10[6];
               rA11 = pA11[6];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rA3 = pA3[7];
               rA4 = pA4[7];
               rA5 = pA5[7];
               rA6 = pA6[7];
               rA7 = pA7[7];
               rA8 = pA8[7];
               rA9 = pA9[7];
               rA10 = pA10[7];
               rA11 = pA11[7];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rA4 = pA4[8];
               rA5 = pA5[8];
               rA6 = pA6[8];
               rA7 = pA7[8];
               rA8 = pA8[8];
               rA9 = pA9[8];
               rA10 = pA10[8];
               rA11 = pA11[8];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rA3 = pA3[9];
               rA4 = pA4[9];
               rA5 = pA5[9];
               rA6 = pA6[9];
               rA7 = pA7[9];
               rA8 = pA8[9];
               rA9 = pA9[9];
               rA10 = pA10[9];
               rA11 = pA11[9];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rA3 = pA3[10];
               rA4 = pA4[10];
               rA5 = pA5[10];
               rA6 = pA6[10];
               rA7 = pA7[10];
               rA8 = pA8[10];
               rA9 = pA9[10];
               rA10 = pA10[10];
               rA11 = pA11[10];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               rA3 = pA3[11];
               rA4 = pA4[11];
               rA5 = pA5[11];
               rA6 = pA6[11];
               rA7 = pA7[11];
               rA8 = pA8[11];
               rA9 = pA9[11];
               rA10 = pA10[11];
               rA11 = pA11[11];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rA2 = pA2[12];
               rA3 = pA3[12];
               rA4 = pA4[12];
               rA5 = pA5[12];
               rA6 = pA6[12];
               rA7 = pA7[12];
               rA8 = pA8[12];
               rA9 = pA9[12];
               rA10 = pA10[12];
               rA11 = pA11[12];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[13];
               rB0 = pB0[13];
               rA1 = pA1[13];
               rA2 = pA2[13];
               rA3 = pA3[13];
               rA4 = pA4[13];
               rA5 = pA5[13];
               rA6 = pA6[13];
               rA7 = pA7[13];
               rA8 = pA8[13];
               rA9 = pA9[13];
               rA10 = pA10[13];
               rA11 = pA11[13];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rA1 = pA1[14];
               rA2 = pA2[14];
               rA3 = pA3[14];
               rA4 = pA4[14];
               rA5 = pA5[14];
               rA6 = pA6[14];
               rA7 = pA7[14];
               rA8 = pA8[14];
               rA9 = pA9[14];
               rA10 = pA10[14];
               rA11 = pA11[14];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[15];
               rB0 = pB0[15];
               rA1 = pA1[15];
               rA2 = pA2[15];
               rA3 = pA3[15];
               rA4 = pA4[15];
               rA5 = pA5[15];
               rA6 = pA6[15];
               rA7 = pA7[15];
               rA8 = pA8[15];
               rA9 = pA9[15];
               rA10 = pA10[15];
               rA11 = pA11[15];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               pA0 += (15*(incAk0));
               pA1 += (15*(incAk0));
               pA2 += (15*(incAk0));
               pA3 += (15*(incAk0));
               pA4 += (15*(incAk0));
               pA5 += (15*(incAk0));
               pA6 += (15*(incAk0));
               pA7 += (15*(incAk0));
               pA8 += (15*(incAk0));
               pA9 += (15*(incAk0));
               pA10 += (15*(incAk0));
               pA11 += (15*(incAk0));
               pB0 += (15*(incBk0));
               break;
            case 16:
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rA4 = pA4[1];
               rA5 = pA5[1];
               rA6 = pA6[1];
               rA7 = pA7[1];
               rA8 = pA8[1];
               rA9 = pA9[1];
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rA6 = pA6[2];
               rA7 = pA7[2];
               rA8 = pA8[2];
               rA9 = pA9[2];
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rA4 = pA4[3];
               rA5 = pA5[3];
               rA6 = pA6[3];
               rA7 = pA7[3];
               rA8 = pA8[3];
               rA9 = pA9[3];
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rA6 = pA6[4];
               rA7 = pA7[4];
               rA8 = pA8[4];
               rA9 = pA9[4];
               rA10 = pA10[4];
               rA11 = pA11[4];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rA3 = pA3[5];
               rA4 = pA4[5];
               rA5 = pA5[5];
               rA6 = pA6[5];
               rA7 = pA7[5];
               rA8 = pA8[5];
               rA9 = pA9[5];
               rA10 = pA10[5];
               rA11 = pA11[5];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rA4 = pA4[6];
               rA5 = pA5[6];
               rA6 = pA6[6];
               rA7 = pA7[6];
               rA8 = pA8[6];
               rA9 = pA9[6];
               rA10 = pA10[6];
               rA11 = pA11[6];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rA3 = pA3[7];
               rA4 = pA4[7];
               rA5 = pA5[7];
               rA6 = pA6[7];
               rA7 = pA7[7];
               rA8 = pA8[7];
               rA9 = pA9[7];
               rA10 = pA10[7];
               rA11 = pA11[7];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rA4 = pA4[8];
               rA5 = pA5[8];
               rA6 = pA6[8];
               rA7 = pA7[8];
               rA8 = pA8[8];
               rA9 = pA9[8];
               rA10 = pA10[8];
               rA11 = pA11[8];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rA3 = pA3[9];
               rA4 = pA4[9];
               rA5 = pA5[9];
               rA6 = pA6[9];
               rA7 = pA7[9];
               rA8 = pA8[9];
               rA9 = pA9[9];
               rA10 = pA10[9];
               rA11 = pA11[9];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rA3 = pA3[10];
               rA4 = pA4[10];
               rA5 = pA5[10];
               rA6 = pA6[10];
               rA7 = pA7[10];
               rA8 = pA8[10];
               rA9 = pA9[10];
               rA10 = pA10[10];
               rA11 = pA11[10];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               rA3 = pA3[11];
               rA4 = pA4[11];
               rA5 = pA5[11];
               rA6 = pA6[11];
               rA7 = pA7[11];
               rA8 = pA8[11];
               rA9 = pA9[11];
               rA10 = pA10[11];
               rA11 = pA11[11];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rA2 = pA2[12];
               rA3 = pA3[12];
               rA4 = pA4[12];
               rA5 = pA5[12];
               rA6 = pA6[12];
               rA7 = pA7[12];
               rA8 = pA8[12];
               rA9 = pA9[12];
               rA10 = pA10[12];
               rA11 = pA11[12];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[13];
               rB0 = pB0[13];
               rA1 = pA1[13];
               rA2 = pA2[13];
               rA3 = pA3[13];
               rA4 = pA4[13];
               rA5 = pA5[13];
               rA6 = pA6[13];
               rA7 = pA7[13];
               rA8 = pA8[13];
               rA9 = pA9[13];
               rA10 = pA10[13];
               rA11 = pA11[13];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rA1 = pA1[14];
               rA2 = pA2[14];
               rA3 = pA3[14];
               rA4 = pA4[14];
               rA5 = pA5[14];
               rA6 = pA6[14];
               rA7 = pA7[14];
               rA8 = pA8[14];
               rA9 = pA9[14];
               rA10 = pA10[14];
               rA11 = pA11[14];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[15];
               rB0 = pB0[15];
               rA1 = pA1[15];
               rA2 = pA2[15];
               rA3 = pA3[15];
               rA4 = pA4[15];
               rA5 = pA5[15];
               rA6 = pA6[15];
               rA7 = pA7[15];
               rA8 = pA8[15];
               rA9 = pA9[15];
               rA10 = pA10[15];
               rA11 = pA11[15];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[16];
               rB0 = pB0[16];
               rA1 = pA1[16];
               rA2 = pA2[16];
               rA3 = pA3[16];
               rA4 = pA4[16];
               rA5 = pA5[16];
               rA6 = pA6[16];
               rA7 = pA7[16];
               rA8 = pA8[16];
               rA9 = pA9[16];
               rA10 = pA10[16];
               rA11 = pA11[16];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               pA0 += (((incAk0) << 4));
               pA1 += (((incAk0) << 4));
               pA2 += (((incAk0) << 4));
               pA3 += (((incAk0) << 4));
               pA4 += (((incAk0) << 4));
               pA5 += (((incAk0) << 4));
               pA6 += (((incAk0) << 4));
               pA7 += (((incAk0) << 4));
               pA8 += (((incAk0) << 4));
               pA9 += (((incAk0) << 4));
               pA10 += (((incAk0) << 4));
               pA11 += (((incAk0) << 4));
               pB0 += (((incBk0) << 4));
               break;
            case 17:
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rA4 = pA4[1];
               rA5 = pA5[1];
               rA6 = pA6[1];
               rA7 = pA7[1];
               rA8 = pA8[1];
               rA9 = pA9[1];
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rA6 = pA6[2];
               rA7 = pA7[2];
               rA8 = pA8[2];
               rA9 = pA9[2];
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rA4 = pA4[3];
               rA5 = pA5[3];
               rA6 = pA6[3];
               rA7 = pA7[3];
               rA8 = pA8[3];
               rA9 = pA9[3];
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rA6 = pA6[4];
               rA7 = pA7[4];
               rA8 = pA8[4];
               rA9 = pA9[4];
               rA10 = pA10[4];
               rA11 = pA11[4];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rA3 = pA3[5];
               rA4 = pA4[5];
               rA5 = pA5[5];
               rA6 = pA6[5];
               rA7 = pA7[5];
               rA8 = pA8[5];
               rA9 = pA9[5];
               rA10 = pA10[5];
               rA11 = pA11[5];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rA4 = pA4[6];
               rA5 = pA5[6];
               rA6 = pA6[6];
               rA7 = pA7[6];
               rA8 = pA8[6];
               rA9 = pA9[6];
               rA10 = pA10[6];
               rA11 = pA11[6];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rA3 = pA3[7];
               rA4 = pA4[7];
               rA5 = pA5[7];
               rA6 = pA6[7];
               rA7 = pA7[7];
               rA8 = pA8[7];
               rA9 = pA9[7];
               rA10 = pA10[7];
               rA11 = pA11[7];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rA4 = pA4[8];
               rA5 = pA5[8];
               rA6 = pA6[8];
               rA7 = pA7[8];
               rA8 = pA8[8];
               rA9 = pA9[8];
               rA10 = pA10[8];
               rA11 = pA11[8];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rA3 = pA3[9];
               rA4 = pA4[9];
               rA5 = pA5[9];
               rA6 = pA6[9];
               rA7 = pA7[9];
               rA8 = pA8[9];
               rA9 = pA9[9];
               rA10 = pA10[9];
               rA11 = pA11[9];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rA3 = pA3[10];
               rA4 = pA4[10];
               rA5 = pA5[10];
               rA6 = pA6[10];
               rA7 = pA7[10];
               rA8 = pA8[10];
               rA9 = pA9[10];
               rA10 = pA10[10];
               rA11 = pA11[10];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               rA3 = pA3[11];
               rA4 = pA4[11];
               rA5 = pA5[11];
               rA6 = pA6[11];
               rA7 = pA7[11];
               rA8 = pA8[11];
               rA9 = pA9[11];
               rA10 = pA10[11];
               rA11 = pA11[11];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rA2 = pA2[12];
               rA3 = pA3[12];
               rA4 = pA4[12];
               rA5 = pA5[12];
               rA6 = pA6[12];
               rA7 = pA7[12];
               rA8 = pA8[12];
               rA9 = pA9[12];
               rA10 = pA10[12];
               rA11 = pA11[12];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[13];
               rB0 = pB0[13];
               rA1 = pA1[13];
               rA2 = pA2[13];
               rA3 = pA3[13];
               rA4 = pA4[13];
               rA5 = pA5[13];
               rA6 = pA6[13];
               rA7 = pA7[13];
               rA8 = pA8[13];
               rA9 = pA9[13];
               rA10 = pA10[13];
               rA11 = pA11[13];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rA1 = pA1[14];
               rA2 = pA2[14];
               rA3 = pA3[14];
               rA4 = pA4[14];
               rA5 = pA5[14];
               rA6 = pA6[14];
               rA7 = pA7[14];
               rA8 = pA8[14];
               rA9 = pA9[14];
               rA10 = pA10[14];
               rA11 = pA11[14];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[15];
               rB0 = pB0[15];
               rA1 = pA1[15];
               rA2 = pA2[15];
               rA3 = pA3[15];
               rA4 = pA4[15];
               rA5 = pA5[15];
               rA6 = pA6[15];
               rA7 = pA7[15];
               rA8 = pA8[15];
               rA9 = pA9[15];
               rA10 = pA10[15];
               rA11 = pA11[15];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[16];
               rB0 = pB0[16];
               rA1 = pA1[16];
               rA2 = pA2[16];
               rA3 = pA3[16];
               rA4 = pA4[16];
               rA5 = pA5[16];
               rA6 = pA6[16];
               rA7 = pA7[16];
               rA8 = pA8[16];
               rA9 = pA9[16];
               rA10 = pA10[16];
               rA11 = pA11[16];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA5 * rB0;
               rC5_0 += m0;
               m0 = rA6 * rB0;
               rC6_0 += m0;
               m0 = rA7 * rB0;
               rC7_0 += m0;
               m0 = rA8 * rB0;
               rC8_0 += m0;
               m0 = rA9 * rB0;
               rC9_0 += m0;
               m0 = rA10 * rB0;
               rC10_0 += m0;
               m0 = rA11 * rB0;
               rA0 = pA0[17];
               rB0 = pB0[17];
               rA1 = pA1[17];
               rA2 = pA2[17];
               rA3 = pA3[17];
               rA4 = pA4[17];
               rA5 = pA5[17];
               rA6 = pA6[17];
               rA7 = pA7[17];
               rA8 = pA8[17];
               rA9 = pA9[17];
               rA10 = pA10[17];
               rA11 = pA11[17];
               rC11_0 += m0;
               m0 = rA0 * rB0;
               pA0 += (((incAk0) << 4)+incAk0);
               pA1 += (((incAk0) << 4)+incAk0);
               pA2 += (((incAk0) << 4)+incAk0);
               pA3 += (((incAk0) << 4)+incAk0);
               pA4 += (((incAk0) << 4)+incAk0);
               pA5 += (((incAk0) << 4)+incAk0);
               pA6 += (((incAk0) << 4)+incAk0);
               pA7 += (((incAk0) << 4)+incAk0);
               pA8 += (((incAk0) << 4)+incAk0);
               pA9 += (((incAk0) << 4)+incAk0);
               pA10 += (((incAk0) << 4)+incAk0);
               pA11 += (((incAk0) << 4)+incAk0);
               pB0 += (((incBk0) << 4)+incBk0);
               break;
            case 0: ;
            }
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA5 * rB0;
            rC5_0 += m0;
            m0 = rA6 * rB0;
            rC6_0 += m0;
            m0 = rA7 * rB0;
            rC7_0 += m0;
            m0 = rA8 * rB0;
            rC8_0 += m0;
            m0 = rA9 * rB0;
            rC9_0 += m0;
            m0 = rA10 * rB0;
            rC10_0 += m0;
            m0 = rA11 * rB0;
            rC11_0 += m0;
            pA0 += incAk0;
            pA1 += incAk0;
            pA2 += incAk0;
            pA3 += incAk0;
            pA4 += incAk0;
            pA5 += incAk0;
            pA6 += incAk0;
            pA7 += incAk0;
            pA8 += incAk0;
            pA9 += incAk0;
            pA10 += incAk0;
            pA11 += incAk0;
            pB0 += incBk0;
            rB0 = alpha;
            rC0_0 *= rB0;
            rC1_0 *= rB0;
            rC2_0 *= rB0;
            rC3_0 *= rB0;
            rC4_0 *= rB0;
            rC5_0 *= rB0;
            rC6_0 *= rB0;
            rC7_0 *= rB0;
            rC8_0 *= rB0;
            rC9_0 *= rB0;
            rC10_0 *= rB0;
            rC11_0 *= rB0;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0[4] = rC4_0;
            pC0[5] = rC5_0;
            pC0[6] = rC6_0;
            pC0[7] = rC7_0;
            pC0[8] = rC8_0;
            pC0[9] = rC9_0;
            pC0[10] = rC10_0;
            pC0[11] = rC11_0;
            pC0 += incCm;
            pA0 += incAm;
            pA1 += incAm;
            pA2 += incAm;
            pA3 += incAm;
            pA4 += incAm;
            pA5 += incAm;
            pA6 += incAm;
            pA7 += incAm;
            pA8 += incAm;
            pA9 += incAm;
            pA10 += incAm;
            pA11 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pA1 += incAn;
         pA2 += incAn;
         pA3 += incAn;
         pA4 += incAn;
         pA5 += incAn;
         pA6 += incAn;
         pA7 += incAn;
         pA8 += incAn;
         pA9 += incAn;
         pA10 += incAn;
         pA11 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_sJIK0x0x0TN1x1x18_aX_bX(k, N, K, alpha, ca + (Mb*lda), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
